using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Migrations;

namespace Benday.EfCore.SqlServer.TestApi.Migrations
{
    public partial class PersonNotes : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
            name: "PersonNote",
            columns: table => new
            {
                Id = table.Column<int>(nullable: false)
                .Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn),
                PersonId = table.Column<int>(nullable: false),
                NoteText = table.Column<string>(nullable: false)
            },
            constraints: table =>
            {
                table.PrimaryKey("PK_PersonNote", x => x.Id);
                table.ForeignKey(
                name: "FK_PersonNote_Person_PersonId",
                column: x => x.PersonId,
                principalTable: "Person",
                principalColumn: "Id",
                onDelete: ReferentialAction.Cascade);
            });
            
            migrationBuilder.CreateIndex(
            name: "IX_PersonNote_PersonId",
            table: "PersonNote",
            column: "PersonId");
        }
        
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
            name: "PersonNote");
        }
    }
}